function [num_H,den_H,num_E,den_E] = lossy_fdn(Fs,Tr,m);
%computes (first-order) lowpass filters H and correction filter E for a fdn,
%given an array of frequency-dependent Tr and the array m of fdn delays

N=length(m);
for i=1:N
    a=10^( -3*m(i)/(Fs*Tr(1)) );
    g2=(log(10)/4)*log10(a)*(1- ( Tr(1)^2/Tr(length(Tr))^2 ) );
    num_H(i,:)=[a*(1-g2), 0]; 
    den_H(i,:)=[1, -g2]; 
end
b=(1-(Tr(length(Tr))/Tr(1)))/(1+(Tr(length(Tr))/Tr(1)));
num_E=[1, -b];    den_E=[1-b, 0];

