% Test the Schroeder reverberator, possibly including early reflections

global Fs;

wavfile= '../../../samples/la.wav';   % input wave file
[x,Fs,Nbits]=wavread(wavfile);

%x=1; %impulse!!!


%%%%%%%%% early reflection parameters %%%%%%%%%%%%%%%%%%%
m_E = round([0 0.0199 0.0354 0.0389 0.0414 0.0699 0.0796]*Fs);
a_E = [1, 1.02 0.818 0.635 0.719 0.267 0.242];

%%%%%%%%%%%%%%% late reverberation parameters %%%%%%%%%%%%%%%%%%
m_H = round([31,37,41,43]*Fs/1000); %comb delays
m_A = round([1.7, 5]*Fs/1000);      %all-pass delays
g_A = [0.7, 0.7];                   %all-pass gains
Tr = 2;                             %reverberation time
g_mix = 1;                          %percentage of reverberated sound mixed
                                    %   with dry sound / early reflections

%%%%%%%%%%%%%% preprocess input signal %%%%%%%%%%%%%%%%%%%%%
if size(x,2)>1 x=x(:,2); end  %if x is stereo use only one channel
x=[x;zeros(Tr*Fs,1)];  %add zeros to x to hear decaying reverberation tail


%%% combination of direct signal and late reverb only
%y = (1-g_mix)*x + g_mix*reverb_schroeder(x,Tr,m_H,m_A,g_A);

%%% early reflections only
%y = reverb_earlyrefl(x, m_E, a_E);

%%% early refl and late reverb according to Schroeder (1970) scheme
y = reverb_schroeder_earlyrefl(x, Tr, m_E, a_E, m_H, m_A, g_A);

y=y/max(1.05*abs(y));
wavwrite(y,Fs,Nbits,'y_schroeder.wav');
